#!/usr/bin/perl
#
# squidGuard-ru.cgi - simple cgi-script to explain in russian to the user
#                     that the URL is blocked and by which rule set
# based on squidGuard.cgi, modified by Vladimir Lettiev aka crux <crux@altlinux.org> 2004
# version: 0.1
#

use strict;
use CGI qw/param/;

my (%client,%HTML);
my $doc_root = $ENV{'DOCUMENT_ROOT'};
my $admin_email = "admin\@example.com";


$HTML{"head"} = <<EOS;
<html>
<head><title>302  ݣ</title>
<meta http-equiv="Content-Type" content="text/html; charset=koi8-r">
</head>
<body>
<h1 align="center"> ݣ</h1>
EOS

$HTML{"userInfo"} = <<EOS;
<table align="center">
<tr>
    <th align="right">IP- <th>=<td align="left">%ip%
<tr>
    <th align="right"> <th>=<td align="left">%name%
<tr>
    <th align="right"><th>=<td align="left">%group%
<tr>
    <th align="right">URL<th>=<td align="left">%url%
</TABLE>
EOS

$HTML{"end"} = <<EOS;
<p align="center">  ,   ,    
   <br><a href="mailto:$admin_email"></a><br><br>
</body>
</html>
EOS

$HTML{"badSite"} = <<EOS;
<p align="center">     ,     ݣ :<br> <b style="color:red">%category%</b></p>
EOS

$HTML{"unknown"} = <<EOS;
<p align="center">   ̣  -</p>
EOS

$HTML{"default"} = <<EOS;
<p align="center"> ip-       </p>
EOS

$HTML{"addr"} = <<EOS;
<p align="center"> ip-  URL </p>
EOS

$HTML{"blocked"} = <<EOS;
<p align="center">     </p>
EOS

# main part

if (param){
	$client{"addr"}		= &parseTag(param('clientaddr'));
	$client{"ident"}	= &parseTag(param('clientident'));
	$client{"srcclass"}	= &parseTag(param('srcclass'));
	$client{"targetclass"}	= &parseTag(param('targetclass'));
	$client{"url"}		= &parseTag(param('url'));

	if (length($client{"url"}) > 53) {
		$client{"url"} = substr($client{"url"},0,50)."...";
	}
	
	my @m = split(/\s+/,scalar gmtime(time));
	if ($m[2] < 10) { $m[2] = "0$m[2]"; }
	print "Expires: $m[0], $m[2] $m[1] $m[4] $m[3] GMT\n";
	
	if ($client{"url"} =~ /\.(gif|jpg|jpeg|jpe|png|mpg|mpeg|avi|mov)$/i) {
		if (open(PNG, "$doc_root/nulbanner.png")){
			print "Content-Type: image/png\n\n";
			while (<PNG>) {
	    	    		print;
			}
			close(PNG)
		} else {
			print "Content-Type: text/plain\n\n";
			print "banner";
		}
	} else {
		print "Content-type: text/html\n\n";
		print $HTML{"head"};
		if ($client{"srcclass"} eq "blocked"){
			print &parseText($HTML{"blocked"});
		} elsif ($client{"srcclass"} eq "unknown"){
			print &parseText($HTML{"unknown"});
		} elsif ($client{"targetclass"} eq "in-addr") {
			print &parseText($HTML{"addr"});
		} elsif ($client{"srcclass"} eq "default") {
			print &parseText($HTML{"default"});
		} else {
			print &parseText($HTML{"badSite"},
				"category" => &po($client{"targetclass"}));
		}
		print &parseText($HTML{"userInfo"},
			"ip"	=> $client{"addr"},
			"name"	=> ($client{"ident"} || "-"),
			"url"	=> $client{"url"},
			"group"	=> &po($client{"srcclass"}),
			"target"=> &po($client{"targetclass"})
		);
		print $HTML{"end"};
	}
} else {
	print "Expires: Thu, 01 Dec 1994 16:00:00 GMT\n";
	print "Content-Type: text/plain\n\n";
	print "error";
}

sub parseTag {
	my $text = shift;
	$text =~ s/>/&gt;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/"/&quot;/g;
	return $text;
}

sub parseText{
	my $text = shift;
	my %tmp  = @_;

	$text=~ s/%(\w+)%/$tmp{$1}/g;
	return $text;
}

sub po {
	my $text = shift;
	my %po = (
		"lan" => " ",
		"admin" => "",
		"blocked" => "",
		
		"local-block" => "  ",
		"ads" => " ",
		"aggressive" => "  ",
		"anecdotes" => "",
		"audio-video" => "  ",
		"drugs" => "    ",
		"gambling" => "on-line , ",
		"hacking" => "  ",
		"mail" => "  ",
		"porn" => "",
		"proxy" => " -",
		"redirector" => "-",
		"violence" => "",
		"warez" => " "
		);
		
	foreach my $key (keys %po){
		if ($key eq $text){
			$text = $po{$key};
			last;
		}
	}
	return $text;
}
